# Copyright (c) 2015 Dave Love, Liverpool University
# MIT licence, per Fedora policy.

# Fixme:
#  Use TDA (from where?)
#  build docs (make doc fails)
#  run test?

%global shortver 2.0
%global vertail .0

Name:		ptf
Version:	%shortver%vertail
Release:	2%{?dist}
Summary:	Periscope online instrumentation and measurement tool
License:	BSD
URL:		http://periscope.in.tum.de/
Source0:	http://periscope.in.tum.de/releases/%shortver/tar/PTF-%version.tar.bz2
Source1:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_Best_Practices_Guide.pdf
Source2:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_CFS_Plugin.pdf
Source3:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_DVFS_Plugin.pdf
Source4:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_FixedAdaptiveSequence_Plugins.pdf
Source5:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_MPIParameters_Plugin.pdf
Source6:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_MasterWorker_Plugin.pdf
Source7:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_Periscope_Users_Guide.pdf
Source8:	http://periscope.in.tum.de/releases/%shortver/pdf/http://periscope.in.tum.de/releases/%shortver/pdf/PTF_Pipeline_Plugin.pdf
BuildRequires:	gcc-gfortran ace-devel >= 5.7
# Required by configure, but not actually used
BuildRequires:	flex bison
%if 0%{?el6}
BuildRequires:	boost148-devel 
%else
BuildRequires:	boost-devel >= 1.47
%endif


%description

Periscope is a scalable automatic performance analysis tool.  It
consists of a frontend and a hierarchy of communication and analysis
agents.  Each of the analysis agents, i.e., the nodes of the agent
hierarchy, searches autonomously for inefficiencies in a subset of the
application processes.

The application processes are linked with a monitoring system that
provides the Monitoring Request Interface (MRI).  The agents attach to
the monitor via sockets. The MRI allows the agent to configure the
measurements; to start, halt, and resume the execution; and to
retrieve the performance data.  The monitor currently only supports
summary information.

The application and the agent network are started through the frontend
process.  It analyzes the set of processors available, determines the
mapping of application and analysis agent processes, and then starts
the application and the agent hierarchy.  After startup, a command is
propagated down to the analysis agents to start the search.  The
search is performed according to a search strategy selected when the
frontend is started.  At the end of the local search, the detected
performance properties are reported back via the agent hierarchy to
the frontend.  Periscope starts its analysis from the formal
specification of performance properties as C++ classes.  The
specification determines the condition, the confidence value, and the
severity of performance properties.

%package doc
Summary:	Documentation for %name
BuildArch:	noarch

%description doc
Documentation for %name.

%prep
%setup -q -n PTF-%version
cp %SOURCE1 %SOURCE2 %SOURCE3 %SOURCE4 %SOURCE5 %SOURCE6 %SOURCE7 %SOURCE8 .


%build
%configure --bindir=%_bindir --libdir=%_libdir \
           --prefix=%_prefix/lib/%name --with-mpi=openmpi \
%if 0%{?el6}
           --with-boost-include=%_includedir/boost148 --with-boost-lib=%_libdir/boost148
%else
#
%endif

make %{?_smp_mflags}


%install
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT/ -name '*.la' -o -name '*.a' | xargs rm


%check
#make check


%files
%doc COPYING
%_bindir/*
%_libdir/*.so*
%_prefix/lib/%name

%files doc
%doc *.pdf


%changelog
* Mon Jan 11 2016 Dave Love <loveshack@fedoraproject.org> - 2.0.0-2
- Don't require scorep2 (though it needs to be used)

* Tue Dec 22 2015 Dave Love <loveshack@fedoraproject.org> - 2.0.0-1
- New version
- Remove fiddles for built files
- Add pdfs in doc subpackage

* Thu Sep  3 2015 Dave Love <loveshack@fedoraproject.org> - 1.0.0-1
- Initial packaging
